#include "colorfade.h"

using namespace Msp;

ColorFadeAction::ColorFadeAction(const GL::Color &c):
	InterpolationAction(HERMITE),
	end_color(c)
{ }

void ColorFadeAction::start(float b, float d)
{
	start_color = get_color();
	if(!start_color.a)
		start_color = GL::Color(end_color.r, end_color.g, end_color.b, 0.0f);
	if(!end_color.a)
		end_color = GL::Color(start_color.r, start_color.g, start_color.b, 0.0f);
	InterpolationAction::start(b, d);
}

void ColorFadeAction::interpolate(float t, float)
{
	GL::Color c = start_color*(1-t)+end_color*t;
	c.a = start_color.a*(1-t)+end_color.a*t;
	set_color(c);
}
